//============================================================================
//  debug.h ufobOwb_t@Cv PS2EE/Win32 
//----------------------------------------------------------------------------
//													Programmed by TAGOCHAN
//----------------------------------------------------------------------------
// 2003.05.06 Ver.1.02 PS2EE Ńt@C݂ɑΉ.
// 2003.02.21 Ver.1.01 JE^ 0 ̎t@C폜悤ɂ.
//                     ֌W̃fobOpɃt@CƍsL.
//                     new/delete I[o[[h.
// 2003.02.20 Ver.1.00 쐬Jn.
//============================================================================

// -------------------- 2 d`h~
#ifndef DEFINE_DEBUG
#define DEFINE_DEBUG

// -------------------- wb_t@Co^
#if defined R5900
#include <stdio.h>
#endif
#include "generic.h"

// fobO (0=Ȃ,1=,2=o͂̂)
#define DEBUG_MODE 2
// o͐ (0=Wo(PS2),fobOEChE(Win32),1=t@C)
#define DEBUG_OUTPUT 1
// DirectX ̃o[W (0=fobOȂ,8  9 ̂ݎw\)
#define DEBUG_DIRECTX 0

// -------------------- NCu̎w
#if defined _WIN32
#if DEBUG_DIRECTX == 8
#pragma comment( lib, "dxerr8.lib" )
#elif DEBUG_DIRECTX == 9
#pragma comment( lib, "dxerr9.lib" )
#endif
#endif

// -------------------- 萔`
static const char* const DEBUG_VERSION = "1.02";
static const char* const DEBUG_NAME = "cDebug";
static const int DEBUG_MEMORY_MAX = 65536;					// mۊĎő吔
#if defined R5900
static const char* const DEBUG_FILE = "host0:DEBUG.TXT";	// PS2EE fobOõ͎t@C
#else
static const char* const DEBUG_FILE = "DEBUG.TXT";			// fobOõ͎t@C
#endif
static const U32 DEBUG_10 = 0;
static const U32 DEBUG_16 = 1;
static const U32 DEBUG_DUMP8  = 0x00000001;
static const U32 DEBUG_DUMP16 = 0x00000002;
static const U32 DEBUG_DUMP32 = 0x00000004;

#if DEBUG_MODE == 1
// -------------------- I[o[Ch
void* operator new( size_t size, const char* file, int line );
void* operator new[]( size_t size, const char* file, int line );
void operator delete( void* ptr );
void operator delete[]( void* ptr );
#endif

#if DEBUG_MODE != 0
// -------------------- NX`
class cDebug {
	private:
		// 풓
		static int StatCount;
		// o
		int OutputType;
		// Ǘ
		static int MallocHandle;
		static const void *MallocAddress[ DEBUG_MEMORY_MAX ];
		static const char *MallocFile[ DEBUG_MEMORY_MAX ];
		static int MallocLine[ DEBUG_MEMORY_MAX ];
		static int MallocSize[ DEBUG_MEMORY_MAX ];
		// ֎~
		cDebug( cDebug& debug );
		cDebug& operator = ( const cDebug &debug );
	public:
		cDebug( void );
		cDebug( int type );
		~cDebug( void );
		// fobOo
		void DeleteFile( void );
		void SetOutputType( int type );
		void Output( const char* outputstring, ... ) const;
		void OutputDump( const void *address, int width, int height, U32 mode ) const;
		// DirectX
		void OutputDxResult( void *result ) const;
		// Ǘ
		void* Malloc( int size, const char *file, int line );
		void Free( void *memblock );
		void MemoryStatus( void );
};
#endif

// -------------------- fobOȂ
#if DEBUG_MODE == 0
#define DEBUGINIT( x )             ;
#define DEBUGOUTMODE( x )          ;
#define DEBUGOUT( x )              ;
#define DEBUGOUTDUMP( a, w, h )    ;
#define DEBUGDX( x )               ;
#define MEMORYSTATE()              ;
// -------------------- ׂ
#elif DEBUG_MODE == 1
#define DEBUGINIT( x )             cDebug DebugMacro( x )
#define DEBUGOUTTYPE( x )          DebugMacro.OutputType( x )
#define DEBUGOUT                   DebugMacro.Output
#define DEBUGOUTDUMP( a, w, h )    DebugMacro.OutputDump( a, w, h, DEBUG_DUMP8 )
#define DEBUGDX( x )               DebugMacro.OutputDxResult( (void*)&x )
#define malloc( x )                DebugMacro.Malloc( x, __FILE__, __LINE__ )
#define free( x )                  DebugMacro.Free( x )
#define MEMORYSTATE()              DebugMacro.MemoryStatus()
#define new                        new( __FILE__, __LINE__ )

// -------------------- o͂̂
#elif DEBUG_MODE == 2
#define DEBUGINIT( x )             cDebug DebugMacro( x )
#define DEBUGOUTTYPE( x )          DebugMacro.OutputType( x )
#define DEBUGOUT                   DebugMacro.Output
#define DEBUGOUTDUMP( a, w, h )    DebugMacro.OutputDump( a, w, h, DEBUG_DUMP8 )
#define DEBUGDX( x )               DebugMacro.OutputDxResult( (void*)&x )
#define MEMORYSTATE()              ;
#endif

// -------------------- ̃t@CQƉ
extern cDebug DebugMacro;

// -------------------- 2 d`h~
#endif
